;Lyrics Window  v1.0 for Dorico by Kenneth Gaw 24/9/2018

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

UID := WinExist("ahk_class Qt5QWindowIcon")

if  (UID = 0)
{
	MsgBox Please open a Dorico score and select a note.
	ExitApp
}
UID := WinExist("Steinberg Hub")

if  (UID != 0)
{
	MsgBox Please open a Dorico score and select a note.
	ExitApp
}


FileRead, GetLyrics, %A_WorkingDir%\Lyrics Window_Data\data.txt
FileRead, GetSpeed, %A_WorkingDir%\Lyrics Window_Data\data2.txt



if !GetLyrics
{
	EnterLyrics:= "Enter lyrics here"
}
else
{
	EnterLyrics:= GetLyrics
}

if !GetSpeed
{	
	strList:= "0.1|0.3|0.5|0.7|1||1.5|2|2.5|3"
}
else
{
	strList:= "0.1|0.3|0.5|0.7|1|1.5|2|2.5|3"
	
	strList:= StrReplace(strList,"|" GetSpeed  "|","|"  GetSpeed  "||") ;makes default
}

Gui, Add, Button, x132 y49 w-60 h130 , Button
Gui, Font, S12 CDefault, Verdana
Gui, Add, Button, x22 y319 w180 h40 , Paste all syllables
Gui, Add, Edit, x20 y9 w450 h290 vLyrics, %EnterLyrics%
Gui, Add, Button, x82 y469 w100 h40 , Cancel
Gui, Add, Button, x22 y389 w260 h40 , Paste one syllable at a time
Gui, Font, S10 CDefault, Verdana
Gui, Font, S8 CDefault, Verdana
Gui, Font, S10 CDefault, Verdana
Gui, Add, ListBox, x432 y329 w30 h180 vVerseNo  +Center, 1||2|3|4|5|6|7|8|9|10
Gui, Add, Text, x432 y309 w50 h20 , Verse
Gui, Add, Text, x22 y429 w280 h20 , (Press the Alt key to enter each syllable)
Gui, Font, S10 CDefault, Verdana
Gui, Font, S12 CDefault, Verdana
Gui, Add, Button, x232 y319 w180 h40 +Center, Consolidate Text
Gui, Add, Button, x312 y389 w100 h40 , Clear Text
Gui, Add, ListBox, x312 y449 w100 h70 vNumSpeed, %strList%
Gui, Add, Text, x202 y469 w100 h30 +Right, Speed
; Generated using SmartGUI Creator 4.0

Gui, Show, x325 y284 h540 w498, Lyrics Window
Return

Escape::
Gui, submit
gosub, SaveData
ExitApp

SaveData:
FileDelete,  %A_WorkingDir%\Lyrics Window_Data\data.txt
FileDelete,  %A_WorkingDir%\Lyrics Window_Data\data2.txt
FileCreateDir, Lyrics Window_Data
FileAppend , %Lyrics%, %A_WorkingDir%\Lyrics Window_Data\data.txt
FileAppend , %NumSpeed%, %A_WorkingDir%\Lyrics Window_Data\data2.txt
Return

ButtonClearText:
Gui, submit
Lyrics  := ""
Gui, Show, x325 y284 h536 w494
GuiControl, Text, Lyrics, %Lyrics%
Return

ButtonConsolidateText:
Gui, submit
newLyrics := Lyrics
newLyrics := StrReplace(newLyrics, ".", ". ") ;ensure space after full stop
newLyrics := StrReplace(newLyrics, ",", ", ") ;ensure space after comma
newLyrics := StrReplace(newLyrics, ":", ": ") ;ensure space after colon
newLyrics := StrReplace(newLyrics, ";", "; ") ;ensure space after semicolon
;any extra spaces created will be removed by the code below
Lyrics := newLyrics
mygo := true
While(mygo = true)
{
	newLyrics := Lyrics

	newLyrics := StrReplace(newLyrics, " `n", "`n") ;remove space at the end of a line
	newLyrics := StrReplace(newLyrics, "`n`n", "`n") ;replace double newline with single newline
	newLyrics := StrReplace(newLyrics, "  ", " ") ;replace double space with space
	newLyrics := StrReplace(newLyrics, "- ", "-") ;replace space-hyphen with hyphen
	newLyrics := StrReplace(newLyrics, "--", "-") ;replace double space with space
	newLyrics := StrReplace(newLyrics, "`n ", "`n") ;remove space at the beginning of a line
	if StrLen(Lyrics) = StrLen(newLyrics) ; both strings the same length. Nothing replaced.
	{
		mygo := false
	}
	else
	{
		Lyrics:= newLyrics
	}
}
Lyrics := Trim(Lyrics, OmitChars := " `n")
Gui, Show, x325 y284 h536 w494, Lyrics Window
GuiControl, Text, Lyrics, %Lyrics%
Return


ButtonCancel:
Gui, submit
gosub, SaveData
ExitApp

GuiClose:
Gui, submit
gosub SaveData
ExitApp

ButtonPasteallsyllables:
Gui, submit
if !Lyrics
{
	FileDelete,  %A_WorkingDir%\Data\data.txt
	FileCreateDir, Data
	FileAppend , %Lyrics%, %A_WorkingDir%\Data\data.txt
	ExitApp
}
gosub, SaveData
WinActivate , ahk_class Qt5QWindowIcon
Send +l
Sleep (200 * NumSpeed)
if(VerseNo > 1)
{
	c = %VerseNo%

	while c > 1
	{
		c := c - 1
		Send {Down}
		Sleep (200 * NumSpeed)
	}

}

newln := "`n"
Lyrics := StrReplace(Lyrics, newln, A_Space)
Lyrics := StrReplace(Lyrics, A_Space,(A_Space . "zzz"))
Lyrics := StrReplace(Lyrics, "-",("-" . "zzz"))
Lyrics := "zzz" . Lyrics

WordArray := StrSplit(Lyrics , A_Space)
Loop % WordArray.Length()
{


	SyllArray :=  StrSplit(WordArray[A_index] , "-")
	OrigLen := SyllArray.Length()
	Loop % SyllArray.Length()
	{
		if(A_index < OrigLen)
		{
			link := "-"
		}
		else
		{
			link := " "
		}
		v := SyllArray[A_Index]
		;MsgBox % SyllArray[A_Index]
		;MsgBox  %link%


		;x := SubStr(SyllArray[A_Index],4)
		;MsgBox %x%
		;MsgBox  %link%

		if(x = "zzz")
		{
			;
		}
		else
		{
			x := SubStr(SyllArray[A_Index],4)
			Sleep (300 * NumSpeed)
			Send %x%
			Sleep (200 * NumSpeed)
		}

		Send %Link%
		Sleep (500 * NumSpeed)
	}

}
Send, +{ENTER}
ExitApp


ButtonPasteonesyllableatatime:
Gui, submit
WinActivate , ahk_class Qt5QWindowIcon
gosub, SaveData
Sleep (100 * NumSpeed)
Send +l
Sleep (200 * NumSpeed)
if(VerseNo > 1)
{
	c = %VerseNo%

	while c > 1
	{
		c := c - 1
		Send {Down}
		Sleep (200 * NumSpeed)
	}
}
newln := "`n"
Lyrics := StrReplace(Lyrics, newln, A_Space)
Lyrics := StrReplace(Lyrics, A_Space,(A_Space . "zzz"))
Lyrics := StrReplace(Lyrics, "-",("-" . "zzz"))
Lyrics := "zzz" . Lyrics
WordArray := StrSplit(Lyrics , A_Space)
Loop % WordArray.Length()
{
	SyllArray :=  StrSplit(WordArray[A_index] , "-")
	OrigLen := SyllArray.Length()
	Loop % SyllArray.Length()
	{
		if(A_index < OrigLen)
		{
			link := "-"
		}
		else
		{
			link := " "
		}
		
		if(x = "zzz")
		{
			;
		}
		else
		{
			x := SubStr(SyllArray[A_Index],4)
			Send %x%
			Sleep (100 * NumSpeed)
		}

		Send %Link%
		Sleep (100 * NumSpeed)
		KeyWait, LAlt,D
	}

}
Send, +{ENTER}
ExitApp



